#version 330

uniform sampler2D u_sampler;

in VertexData {
    vec2 texCoords;
} inData;

out vec4 fragmentColor;

uniform vec4 uColor = vec4(1, 0, 0, 1);
uniform int uDistance = 2;

void main() {
    vec2 size = vec2(textureSize(u_sampler, 0));

    int d = uDistance * uDistance * 2;
    int f = 0;

    for (int y = -uDistance; y <= uDistance; ++y)
    {
        for (int x = -uDistance; x <= uDistance; ++x)
        {
            vec2 texCoords = vec2(x, y) / size + inData.texCoords;
            vec4 color = texture(u_sampler, texCoords);

            if (color.r > 0)
            {
                d = min(d, x * x + y * y);
                f++;
            }
        }
    }

    vec4 color = vec4(0);

    if (f > 0)
    {
        if (d > (uDistance - 1) * (uDistance - 1))
        {
            color = vec4(0, 0, 0, 1);
        }
        else
        {
            color = uColor;
        }
    }

    fragmentColor = color;
}
